#!/bin/sh
# the next line restarts using tclsh \
exec tclsh "$0" "$@"

# $Id: canvas-man.tcl,v 1.6 2003/11/02 11:02:57 baum Exp $

# ensure that "." is the decimal point
set ::env(LC_NUMERIC) "C"

set auto_path [linsert $auto_path 0 \
      [file join [file dirname [info script]] ../../src]]

package require Gnocl
# test, if Gnocl is loaded two times
package require GnoclCanvas

set canv [gnocl::canvas -background white]
set coords {10 100 30 60 50 20 110 20 150 60 190 100}
foreach {x y} $coords {
   $canv create ellipse -coords [list $x $y 3] -centerRadius 1 -fill darkgreen \
   -onButtonPress "puts pressed" -onButtonRelease "puts released"
}
$canv create bPath -coords [lrange $coords 2 9] -outline red -width 2
$canv create line -coords [lrange $coords 0 5] -fill blue
$canv create line -coords [lrange $coords 6 11] -fill blue
$canv create ellipse -coords {70 140 50} -centerRadius 1 -fill "" -outline mediumOrchid
$canv create rectangle -coords {110 105 180 180} -fill "" -outline green

$canv create text -coords {80 100} -text "gnocl" -font "Utopia 14"

gnocl::window -title "Canvas" -child $canv -onDestroy exit

gnocl::mainLoop

