#!/bin/sh
# the next line restarts using tclsh \
exec tclsh "$0" "$@"

# $Id: test-canvas-bpath.tcl,v 1.6 2003/11/02 11:02:57 baum Exp $

# ensure that "." is the decimal point
set ::env(LC_NUMERIC) "C"

set auto_path [linsert $auto_path 0 \
      [file join [file dirname [info script]] ../../src]]
package require GnoclCanvas

set canvas [gnocl::canvas -background white -antialiased 1]
set right [gnocl::box -orientation vertical -homogeneous 0]
set mainBox [gnocl::box -orientation horizontal \
      -children $canvas -expand 1 -fill 1 -homogeneous 0]
$mainBox add $right -expand 0

set x0 10
set y0 120
set coords [list $x0 $y0]
set dy 100
foreach x {0 10 20 30 40} {
   lappend coords [expr {$x0+$x}] [expr {$y0+$dy}] \
         [expr {$x0+100-$x}] [expr {$y0+$dy}] \
         [expr {$x0+100}] $y0
   set dy [expr {$dy*-1}]
   incr x0 100
}
foreach {x y} $coords {
   $canvas create ellipse -coords [list $x $y 2] -fill darkgreen
}

$canvas create bPath -coords $coords -outline blue -tags "bpath bpath1"

set x0 10
set y0 340
set coords [list $x0 $y0]
set dy 100
foreach dy {100 -80 60 -40 20} {
   lappend coords [expr {$x0+20}] [expr {$y0+$dy}] \
         [expr {$x0+80}] [expr {$y0+$dy}] \
         [expr {$x0+100}] $y0
   incr x0 100
}
foreach {x y} $coords {
   $canvas create ellipse -coords [list $x $y 2] -fill darkgreen -tags bpath2
}
$canvas create bPath -coords $coords -outline blue -tags "bpath bpath2"

$canvas rotate bpath2 "300 340 0.2"

$right add [gnocl::label -text "outline:"] -expand 0
$right add [gnocl::optionMenu -items {blue red darkgreen} \
      -onChanged "$canvas itemConfigure bpath -outline %v"]
$right add [gnocl::label -text "width:"] -expand 0
$right add [gnocl::spinButton -digits 0 -lower 1 -upper 30 \
      -onValueChanged "$canvas itemConfigure bpath -width %v"] -expand 0
$right add [gnocl::label -text "capStyle:"] -expand 0
$right add [gnocl::optionMenu -items {notLast butt round projecting} \
      -onChanged "$canvas itemConfigure bpath -capStyle %v"]
$right add [gnocl::label -text "joinStyle:"] -expand 0
$right add [gnocl::optionMenu -items {miter round bevel} \
      -onChanged "$canvas itemConfigure bpath -joinStyle %v"]

# $right add [gnocl::label -text "wind:"] -expand 0
# $right add [gnocl::spinButton -digits 0 -lower 1 -upper 300 \
#       -onValueChanged "$canvas itemConfigure bpath -wind %v"] -expand 0
# $right add [gnocl::label -text "miterLimit:"] -expand 0
# $right add [gnocl::spinButton -digits 1 -lower 1 -upper 300 \
#       -onValueChanged "$canvas itemConfigure bpath -miterLimit %v"] -expand 0

proc bgerror { err } {
   puts "in bgerror: $err"
   puts $::errorInfo
   # puts "errorCode: $::errorCode"
}

set win [gnocl::window -child $mainBox -onDestroy exit \
      -defaultHeight 500 -defaultWidth 700]

gnocl::mainLoop

