#!/bin/sh
# the next line restarts using tclsh \
exec tclsh "$0" "$@"

# $Id: test-canvas-tags.tcl,v 1.6 2003/11/02 11:02:57 baum Exp $

# ensure that "." is the decimal point
set ::env(LC_NUMERIC) "C"

set auto_path [linsert $auto_path 0 \
      [file join [file dirname [info script]] ../../src]]
package require GnoclCanvas

set pi2 [expr {-2.*atan(1)}]

set canvas [gnocl::canvas -antialiased 1 -background white]
      # -scrollRegion {0 0 500 500} -scrollbar never]

proc createItems { canv tags x y } {
   $canv create text -coords [list $x $y] -text $tags -tags $tags
   $canv create line -width 2 -tags $tags -coords \
         [list [expr {$x-10}] [expr {$y-10}] [expr {$x+10}] [expr {$y+10}]] 
   $canv create line -coords "-10 -10 10 10" -width 2
}

createItems $canvas {top left} 100 100
createItems $canvas {top right} 300 100
createItems $canvas {bottom left} 100 300
createItems $canvas {bottom right} 300 300

$canvas itemConfigure right -fill blue
$canvas itemDelete bottom
$canvas create rectangle -coords [$canvas getBounds top] -fill {} \
      -outline yellow


set win [gnocl::window -title "Canvas Line Test" -child $canvas \
      -defaultWidth 500 -defaultHeight 500 -onDestroy exit]

gnocl::mainLoop

