#!/bin/sh
# the next line restarts using tclsh \
exec tclsh "$0" "$@"

# $Id: test-canvas-widget.tcl,v 1.6 2003/11/02 11:02:57 baum Exp $

# ensure that "." is the decimal point
set ::env(LC_NUMERIC) "C"

set auto_path [linsert $auto_path 0 \
      [file join [file dirname [info script]] ../../src]]
package require GnoclCanvas

set canvas [gnocl::canvas -antialiased 1 -background white \
      -width 500 -height 500]

# anchor
set x 250
set y 50
foreach el {center N NW NE S SW SE W E} {
   $canvas create widget -coords [list $x $y] -width 100 -height 25 \
         -widget [gnocl::button -text "anchor $el" \
         -onClicked "puts \"anchor $el\""] -anchor $el
   $canvas create ellipse -coords [list $x $y 3] -centerRadius 1 -fill red
   incr y 50
}

set win [gnocl::window -child $canvas -defaultWidth 500 -defaultHeight 500 \
         -onDestroy exit]

gnocl::mainLoop

