#!/bin/sh
# the next line restarts using tclsh \
exec tclsh "$0" "$@"

# $Id: test-clipboard.tcl,v 1.6 2003/11/02 11:02:54 baum Exp $

# ensure that "." is the decimal point
set ::env(LC_NUMERIC) "C"

set auto_path [linsert $auto_path 0 [file join [file dirname [info script]] ../src]]
package require Gnocl

gnocl::clipboard clear
if { [gnocl::clipboard hasText] } {
   puts "Error: clipboard should be empty"
}

set txt "abcd"
gnocl::clipboard setText $txt
set ret [gnocl::clipboard getText]
if { [string length $ret] != [string length $txt] \
      || [string compare $ret $txt] != 0 } {
   error "$ret != $txt"
}
puts [format "length: %d == %d; %s == %s" [string length $txt] \
      [string length $ret] $txt $ret]

gnocl::clipboard clear
if { [gnocl::clipboard hasText] } {
   error "clipboard should be empty"
}

# if { $argc == 1 } {
#    set win [gnocl::plug -socketID [lindex $argv 0] -child $mainBox -onDestroy exit]
# } else {
#    set win [gnocl::window -child $mainBox -onDestroy exit]
# }

#gnocl::mainLoop

